/*
 * Generates all 2^21 newsham-21 keys
 */

#include <stdio.h>

int main (int argc, char **argv)
{
  int i, j, k;
  unsigned val;


  for (i = 0; i < (1024 * 1024 * 8); i++) {
      if ((i & 0x8000) != 0) {
        i+=0x7FFF;
	continue;
      }
      if ((i & 0x80) != 0) {
        i+=0x7F;
	continue;
      }

      val = i;

      for (j = 0; j < 1; j++) {
	  for (k = 0; k < 5; k++) {
	      val *= 0x000343fd;
	      val += 0x00269ec3;
	      printf ("%02X", (val & 0x00FF0000) >> 16);
	      if ((k % 5) == 4)
		puts ("");
	    }
	}
    }

  return 0;
}
